import { IModalMenu } from "@wangeditor/editor-for-vue";

export class BigFileUploadMenu implements IModalMenu {
  title: string;
  tag: string;
  showModal: boolean;
  modalWidth: number;
  iconSvg: string;

  constructor() {
    this.title = "图片上传";
    this.iconSvg =
      '<svg viewBox="0 0 1024 1024" version="1.1" ><path d="M320 627.2l29.866667-29.866667 29.866666 29.866667 64 64 149.333334-149.333333 29.866666-29.866667 29.866667 29.866667 196.266667 196.266666V298.666667H213.333333v435.2l106.666667-106.666667z m29.866667 29.866667L238.933333 768h136.533334l-4.266667-4.266667 42.666667-42.666666-64-64zM823.466667 768l-196.266667-196.266667-196.266667 196.266667h392.533334zM896 256v554.666667H170.666667V256h725.333333z" fill="#444444" p-id="2819"></path></svg>';
    this.tag = "button";
    this.showModal = true;
    this.modalWidth = 270;
  }

  isActive(_editor: IDomEditor): boolean {
    return false;
  }
  getValue(_editor: IDomEditor): string | boolean {
    return "";
  }
  isDisabled(_editor: IDomEditor): boolean {
    return false;
  }
  exec(_editor: IDomEditor, value: string | boolean) {}
  // 弹出框 modal 的定位：1. 返回某一个 SlateNode； 2. 返回 null （根据当前选区自动定位）
  getModalPositionNode(_editor: IDomEditor): SlateNode | null {
    return null;
  }

  // 定义 modal 内部的 DOM Element
  getModalContentElem(editor: IDomEditor): DOMElement {
    const $li = $("<ul style='width: 100%;'></ul>");
    const $content = $("<div style='height: 250px;overflow-y: auto;'></div>");
    const $button = $(
      "<div style='width: 100%; height:50px;'><button style='height: 30px;  display: flex;justify-content: center;align-items: center; '>上传图片</button></div>"
    );
    $content.append($button);

    $button.on("click", () => {
      const input = document.createElement("input");
      input.type = "file";
      input.accept = "image/*";
      input.addEventListener("change", event => {
        let imgstring: string = "";
        const file = (event.target as HTMLInputElement).files![0];
        const reader = new FileReader();
        let img_url = "";
        reader.onload = async () => {
          let values = ref<FieldValues>({
            content: ""
          });
          const base64String = reader.result as string;
          imgstring =
            '<img src="' +
            base64String +
            '" alt="图片.jpg" data-href="" style=""/>';
          values.value.content = imgstring;
          const rep_data: any = await 上传图片接口(values);
          let imgcont = rep_data.content;
          img_url =
            '<img src="' +
            imgcont +
            '" alt="图片.jpg" data-href="" style="height: 90px; width:auto;"/>';
          let imgbutt =
            "<button id='test' style='height: 30px; margin-top: 10px;'>复制图片代码</button>";
          let imgbt = "<li >" + img_url + imgbutt + "</li>";
          let imght =
            "<img src='" + imgcont + "' style='height: 373px; width:274; '/>";
          const $img_urls = $(imgbt);
          $content.append($li.append($img_urls));
          $("#test").on("click", async () => {
            // await toClipboard(imght);
            console.log("复制成功!");
          });
        };
        reader.readAsDataURL(file);
      });
      input.click();
    });

    return $content[0];
  }
}
