import { Menu, IMenuOption } from "@wangeditor/editor-for-vue";

// 自定义插入变量菜单
class InsertVariableMenu extends Menu {
  // 构造菜单
  constructor() {
    const options: IMenuOption = {
      key: "insertVariable", // 唯一标识
      title: "插入变量", // 菜单名称
      iconSvg: "<svg></svg>" // 菜单图标（可选，使用自定义的图标）
    };
    super(options);
  }

  // 点击菜单时的操作
  exec(editor: IDomEditor) {
    // 在光标位置插入特定内容，比如插入一句话
    const contentToInsert = "<p>这是插入的变量内容</p>";
    editor.insertHtml(contentToInsert); // 插入 HTML
  }
}

export { InsertVariableMenu };
