import type {
  IModalMenu,
  IDomEditor,
  SlateNode
} from "@wangeditor/editor-for-vue";

export class BigFileUploadMenu implements IModalMenu {
  title: string;
  tag: string;
  showModal: boolean;
  modalWidth: number;
  iconSvg: string;

  constructor() {
    this.title = "推按";
    this.iconSvg =
      '<svg viewBox="0 0 1024 1024" version="1.1" ><path d="M320 627.2l29.866667-29.866667 29.866666 29.866667 64 64 149.333334-149.333333 29.866666-29.866667 29.866667 29.866667 196.266667 196.266666V298.666667H213.333333v435.2l106.666667-106.666667z m29.866667 29.866667L238.933333 768h136.533334l-4.266667-4.266667 42.666667-42.666666-64-64zM823.466667 768l-196.266667-196.266667-196.266667 196.266667h392.533334zM896 256v554.666667H170.666667V256h725.333333z" fill="#444444" p-id="2819"></path></svg>';
    this.tag = "button";
    this.showModal = true;
    this.modalWidth = 270;
  }

  isActive(_editor: IDomEditor): boolean {
    return false;
  }
  getValue(_editor: IDomEditor): string | boolean {
    return "";
  }
  isDisabled(_editor: IDomEditor): boolean {
    return false;
  }
  exec(_editor: IDomEditor, value: string | boolean) {}
  // 弹出框 modal 的定位：1. 返回某一个 SlateNode； 2. 返回 null （根据当前选区自动定位）
  getModalPositionNode(_editor: IDomEditor): SlateNode | null {
    return null;
  }

  // 定义 modal 内部的 DOM Element
  getModalContentElem(editor: IDomEditor) {
    return "22";
  }
}
