import type {
  IModalMenu,
  IDomEditor,
  SlateNode
} from "@wangeditor/editor-for-vue";

export class BigFileUploadMenu implements IModalMenu {
  title: string;
  tag: string;
  showModal: boolean;
  modalWidth: number;
  iconSvg: string;

  constructor() {
    this.title = "插入变量";
    this.tag = "button";
    this.showModal = true;
    this.modalWidth = 270;
  }

  isActive(_editor: IDomEditor): boolean {
    return false;
  }
  getValue(_editor: IDomEditor): string | boolean {
    return "";
  }
  isDisabled(_editor: IDomEditor): boolean {
    return false;
  }
  exec(_editor: IDomEditor, value: string | boolean) {}
  // 弹出框 modal 的定位：1. 返回某一个 SlateNode； 2. 返回 null （根据当前选区自动定位）
  getModalPositionNode(_editor: IDomEditor): SlateNode | null {
    return null;
  }

  // 定义 modal 内部的 DOM Element
  getModalContentElem(editor: IDomEditor) {
    const input = document.createElement("input");
    // 监听回车事件
    input.addEventListener("keypress", (event: KeyboardEvent) => {
      if (event.key === "Enter") {
        // 当用户按下回车键时执行的代码
        console.log("Enter key pressed in input", input.value);
        const html = editor.getHtml();
        editor.setHtml(html + `<span>{{${input.value}}}</span>`);
        // 你可以在这里添加你需要的逻辑，比如提交表单或关闭模态框等
      }
    });
    console.log("modal内部", editor);
    return input;
  }
}
