import { http } from "@/utils/http";

type Result = {
  success: boolean;
  data?: Array<any>;
};

type ResultTable = {
  success: boolean;
  data?: {
    /** 列表数据 */
    records: Array<any>;
    /** 总条目数 */
    total?: number;
    /** 每页显示条目个数 */
    pageSize?: number;
    /** 当前页数 */
    pageNum?: number;
  };
};
const baseUrl = "/api";
export default {
  /** 查 */
  fetch(params?: object) {
    return http.request<ResultTable>(
      "get",
      baseUrl + "/system/dynamicParameter/list",
      {
        params
      }
    );
  },

  /** 新增 */
  add(data?: object) {
    return http.request<Result>("post", baseUrl + "/system/dynamicParameter", {
      data
    });
  },

  /** 更改 */
  update(data?: object) {
    return http.request<Result>("put", baseUrl + "/system/dynamicParameter", {
      data
    });
  },

  /** 删除 */
  remove(params?: number) {
    return http.request<Result>(
      "delete",
      baseUrl + "/system/dynamicParameter/" + params
    );
  }
};
