import { defineStore } from "pinia";
import dynamicParameterApi from "@/api/messagePlatform/dynamicParameter";
import messageGatewayApi from "@/api/messagePlatform/messageGateway";
import { store } from "../utils";
export const useMessagePlatform = defineStore({
  id: "message-platform",
  state: () => ({
    //动态属性列表
    dynamicParameterList: [],
    //网关列表
    messageGatewayList:[]
  }),
  actions: {
    /** 获取列表信息 */
    async saveDynamicParameterList() {
      return new Promise((resolve, reject) => {
        dynamicParameterApi
          .fetch({ pageNum: 1, pageSize: 10000 })
          .then(data => {
            if (data) this.dynamicParameterList = data.data.records;
            resolve(data);
          })
          .catch(error => {
            reject(error);
          });
      });
    },
    /** 请求网关列表信息 */
    async reqMessageGatewayList() {
      return new Promise((resolve, reject) => {
        messageGatewayApi
          .fetch({ pageNum: 1, pageSize: 10000 })
          .then(data => {
            if (data) this.saveMessageGatewayList(data.data.records)
            resolve(data);
          })
          .catch(error => {
            reject(error);
          });
      });
    },
    /** 保存网关列表列表信息 */
    async saveMessageGatewayList(list) {
      this.messageGatewayList = list
    }
  }
});

export function useMessagePlatformHook() {
  return useMessagePlatform(store);
}
