

import { type Ref, reactive, ref, onMounted, h, toRaw, watch, computed } from "vue";
import { menuGateWayTypeOptions } from "@/utils/enums/gatewayType";
import messageSceneTemplateApi from "@/api/messagePlatform/messageSceneTemplate";
import { message } from "@/utils/message";
export function useMessageTemplate(newFormInline) {
  let formData = ref({
    id: "",
    applicationId: "",
    sceneId: "",
    gatewayType: "",
    templateContent: "",
    autoParameterDefine: "",
    status: "",
  });
  const autoParameterDefine = ref([])
  const gatewayTypeList = computed(() => {
    console.log("1111", newFormInline);
    let array = newFormInline?.sendTypeDescribe ? newFormInline.sendTypeDescribe.split(";") : []
    array = array.map(item => {
      let itemValue = item.split(",")
      let res = menuGateWayTypeOptions.find(
        items => items.value == itemValue[0]
      );
      let obj = { label: res ? res.label : "", value: itemValue[0] }
      return obj
    })
    return array
  })


  const handleChangeGatewayeType = async (value) => {
    formData.value.sceneId = newFormInline.sceneId
    formData.value.applicationId = newFormInline.applicationId
    formData.value.gatewayType = value
    const { data } = await messageSceneTemplateApi.fetch({ gatewayType: value, sceneId: newFormInline.sceneId })
    console.log("pp", data);
    if (data.id) {
      formData.value = data
    } else {
      formData.value.autoParameterDefine = ""
      formData.value.templateContent = ""
    }
    autoParameterDefine.value = formData.value.autoParameterDefine ? JSON.parse(formData.value.autoParameterDefine) : []

  }

  function extractValues(text) {
    // 使用正则表达式匹配所有 {{}} 中的内容
    const regex = /{{([^}]*)}}/g;
    let match;
    const result = [];
    // 循环查找所有匹配项
    while ((match = regex.exec(text)) !== null) {
      // match[1] 是捕获组中的内容，即 {{}} 中的值
      if (match[1].trim() !== "") {
        // 忽略空值或只有空格的值
        let res = autoParameterDefine.value.find(item => item.label == match[1].trim())
        console.log("111", autoParameterDefine.value, match[1].trim());

        if (res) {
          result.push({ label: `${match[1].trim()}`, title: res.title });
        } else {
          result.push({ label: `${match[1].trim()}`, title: "" });
        }

      }
    }
    return result;
  }
  // 提交表单
  const submitForm = async () => {
    console.log("11", autoParameterDefine.value);

    formData.value.autoParameterDefine = JSON.stringify(autoParameterDefine.value)
    if (formData.value.id) {
      // 实际开发先调用新增接口，再进行下面操作
      await messageSceneTemplateApi.update(toRaw(formData.value));
    } else {
      await messageSceneTemplateApi.add(toRaw(formData.value));
    }
    message(`更改成功`, {
      type: "success"
    });
  };
  const resetForm = () => {
    autoParameterDefine.value.forEach((item) => {
      item.title = ""
    })
  }
  onMounted(() => {
    handleChangeGatewayeType(formData.value.gatewayType)

  })


  return {
    formData,
    gatewayTypeList,
    handleChangeGatewayeType,
    autoParameterDefine,
    submitForm,
    extractValues,
    resetForm
  };
}
