import dynamicParameterApi from "@/api/messagePlatform/dynamicParameter";
import { onMounted, ref } from "vue";
import { useMessagePlatformHook } from "@/store/modules/messagePlatform";
export default function () {
  const dataList = ref([]);
  const loading = ref(false);
  const gatewayType = ref(null);
  /** 获得动态属性列表 */
  const onSearch = async params => {
    console.log("111",params);

    if(!params.gatewayType) {
      return;
    }

    const { data } = await dynamicParameterApi.fetch({
      pageNum: 1,
      pageSize: 10000,
      name: params?.name ?? undefined,
      gatewayType: params?.gatewayType ?? undefined
    });
    gatewayType.value = params?.gatewayType ?? undefined;
    dataList.value = data.records;
  };
  const remoteMethod = query => {
    if (query) {
      loading.value = true;
      onSearch({ name: query, gatewayType: gatewayType.value });
      loading.value = false;
    } else {
      dataList.value = [];
    }
  };
  return {
    dataList,
    onSearch,
    remoteMethod,
    loading
  };
}
